#include "computewidget.h"
#include "ui_computewidget.h"

ComputeWidget::ComputeWidget(QWidget *parent) :
    QWidget(parent),
    ui(new Ui::ComputeWidget)
{
    ui->setupUi(this);
    ui->lComputeIcon->setPixmap(QPixmap(":/new/icons/compute.png").scaled(80, 55, Qt::KeepAspectRatio));
}

void ComputeWidget::setID(std::string _id){
    id = _id;
}

void ComputeWidget::setName(std::string _name){
    name = _name;
    ui->lHostName->setText(_name.c_str());
}

ComputeWidget::~ComputeWidget()
{
    delete ui;
}

void ComputeWidget::on_bRenew_clicked()
{
    emit renew(id);
}

void ComputeWidget::on_bStart_clicked()
{
    emit start(id);
}

void ComputeWidget::on_bWakeUpSleep_clicked()
{
    emit wakeupsleep(id);
}

void ComputeWidget::stateChangedHandler(std::string newState, std::string _id){
    if(id == _id){ //check if we changed or not
        if(newState == "suspended" || newState == "inactive"){
            ui->bWakeUpSleep->setText("Wake up");
            ui->bWakeUpSleep->setStyleSheet("background-color:green");
        }
        else if(newState == "active"){
            ui->bWakeUpSleep->setText("Sleep");
            ui->bWakeUpSleep->setStyleSheet("background-color:yellow");
        }
        else
            throw std::runtime_error("undefined VM state!");
    }
}
