#include "controller.h"

bool Controller::connect(std::string url){
    session = new OcciClient::OcciSession(url.c_str(), true, true);
    return true; //TODO validation
}

bool Controller::login(std::string username, std::string password){
    session->circleOcciLogin(username, password);
    if(username == "admin" && password == "admin"){ //TODO TODO lib should handle this
        refresh(); //initialize data
        return true;
    }
    return false;
}

/*!
 * \brief Refreshes all data, communicates with the server
 */
void Controller::refresh(){
    allCompute.clear();
    for(auto c : OcciClient::Compute::getComputeInstances(session))
        allCompute.push_back(c);
    allTemplate.clear();
    for (auto t : OcciClient::getTemplates(session))
        allTemplate.push_back(t);
}

std::vector<std::string> Controller::getVMs(){
    std::vector<std::string> VMs;
    for(auto c : allCompute){
        VMs.push_back(c->getHostname());
    }
    return VMs;
}

std::vector<std::string> Controller::getTemplates(){
    std::vector<std::string> templates;
    for(auto t : allTemplate){
        templates.push_back(t);
    }
    return templates;
}

void Controller::renewByID(std::string id){
    allCompute.at(std::stoi(id))->renew();
    refresh();
}

void Controller::startByID(std::string id){
    allCompute.at(std::stoi(id))->start();
    refresh();
}

void Controller::wakeupByID(std::string id){
    allCompute.at(std::stoi(id))->wakeup();
    refresh();
}

void Controller::sleepByID(std::string id){
    allCompute.at(std::stoi(id))->sleep();
    refresh();
}

std::string Controller::getState(std::string id){
    return allCompute.at(std::stoi(id))->getState();
}

ComputeData Controller::getDataByID(std::string id){
    ComputeData data;
    data.memory = allCompute.at(std::stoi(id))->getMemory();
    data.cpu = allCompute.at(std::stoi(id))->getCpuShare();
    data.cores = allCompute.at(std::stoi(id))->getCores();
    data.hostname = allCompute.at(std::stoi(id))->getCredentialHost();
    data.port = allCompute.at(std::stoi(id))->getCredentialPort();
    data.username = allCompute.at(std::stoi(id))->getCredentialUsername();
    data.password = allCompute.at(std::stoi(id))->getCredentialPassword();
    return data;
}

void Controller::newCompute(Template t){
    OcciClient::Compute::createComputeInstance(session, t);
    refresh();
}
